// Basic types Demo
#include <stdio.h>
#include <float.h>		// limits of floating point types
#include <limits.h>		// limits of other simple types

int main(int argc, char* argv[])
{
	// definition and output of basic types
	char c=65; 
	int i=10;
	float f=2.1111f; 
	float ff=1.0e12f;
	double d=1.0e250;
	printf("Examples for simle types\n");
	printf("Output: c=%4c \ti=%d \tf=%.2f \td=%e\n",c,i,f,d);

	// limits:
	printf("\nLimits of simple types:\n");
	printf("Maximum positive float value: %e\n",FLT_MAX);
	printf("Minimum positive float value: %e\n",FLT_MIN);
	printf("Maximum positive double value: %e\n",DBL_MAX);
	printf("Minimum positive double value: %e\n",DBL_MIN);
	printf("Maximum (signed) char value: %d\n",SCHAR_MAX);
	printf("Minimum (signed) char value: %d\n",SCHAR_MIN);
	printf("Maximum (signed) short value: %d\n",SHRT_MAX);
	printf("Minimum (signed) short value: %d\n",SHRT_MIN);
	printf("Maximum (signed) int value: %d\n",INT_MAX);
	printf("Minimum (signed) int value: %d\n",INT_MIN);

	// type conversion
	printf("\nExamples for type conversion");
	int f_int=(int) f;			// explicit conversion -> decimal digits lost
	float i_float=i;			// implicit conversion
	printf("\ni=%d i_float=%f \tf=%f f_int=%d\n",i,i_float,f,f_int);

	float d_float1=(float) d;	// Number to big for a float variable!
	float d_float2=1.0e250;		// Number to big for a float variable!
	printf("d=%e d_float1=%e d_float2=%e \n",d,d_float1,d_float2);
		
	float g=7/3;			// integer division then conversion to float
	float h=7.0f/3;			// 3 is converted to float and then float division
	printf("g=7/3=%f h=7.0/3=%f\n",g,h);

	return 0;
}
